<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class Pla02600 extends \Zeedhi\Framework\Controller\Report {

    protected $birtStrategy;
    protected $crudService;

    public function __construct($reportService, $birtStrategy, $crudService, $parameterBag) {
        $this->reportService = $reportService;
        $this->birtStrategy   = $birtStrategy;
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
    }

    protected $reportMapping = array (
        'pla02600' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'      => 'CDFILIAL',
                        'SEMANAINICIAL' => 'DTINICIAL',
                        'SEMANAFINAL'   => 'DTFINAL',
                        'CDDIETA'       => 'CDDIETA',
                        'NRORG'         => 'NRORG',
                        'CDSERVFILI'    => 'LISTASERVICO',
                        'IMPCOMENSAIS'  => 'IMPCOMENS',
                        'QUEBRARPAG'    => 'QUEBRARPAG',
                        'AGRUPAR'       => 'AGRUPAR',
                        'IMPMENSAGEM'   => 'IMPMENSAGEM',
                        'IMPNMFANTASIA' => 'IMPNMFANTASIA',
                        'QUEBRAMES'     => 'QUEBRAMES'
                    ),
            ),
        'pla02602' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'      => 'CDFILIAL',
                        'SEMANAINICIAL' => 'DTINICIAL',
                        'SEMANAFINAL'   => 'DTFINAL',
                        'CDDIETA'       => 'CDDIETA',
                        'NRORG'         => 'NRORG',
                        'CDSERVFILI'    => 'LISTASERVICO',
                        'IMPCOMENSAIS'  => 'IMPCOMENS',
                        'QUEBRARPAG'    => 'QUEBRARPAG',
                        'AGRUPAR'       => 'AGRUPAR',
                        'IMPMENSAGEM'   => 'IMPMENSAGEM',
                        'IMPNMFANTASIA' => 'IMPNMFANTASIA',
                        'QUEBRAMES'     => 'QUEBRAMES',
                        'NRTIPOCUSTO'   => 'NRTIPOCUSTO',
                        'TPDATA'        => 'TPDATA'
                    ),
            ),
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }

    public function consultaConfigCardapio(DTO\Request\Filter $request, DTO\Response $response){
        $dataSourceName = "pla02600_consulta_config_cardapio";
        $parameterBagColumns = array('CDFILIAL',  'CDSERVFILI', 'DTINICIAL', 'DTFINAL', 'NRORG');

        try {
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($dataSourceName);
            $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $parameterBagColumns);
            $this->crudService->find($response, $newFilterCriteria);
        } catch (\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 500));
        }
    }
}