<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;


class DietaPadraoController extends \Teknisa\GER\Controllers\TeknisaCrud {
	protected $parameterBagColumns;
	protected $crudService;
	protected $dataSourceManager;
	protected $environment;
	protected $parameterBag;
	protected $imgPathURL;
	protected $dataSourceName = "ger09200_dieta_padrao";
	
	public function __construct($crudService, $parameterBag, $dataSourceManager, $environment, $entityManager, $imgPathURL){
		$this->crudService 	        = $crudService;
	    $this->parameterBag         = $parameterBag;
		$this->dataSourceManager    = $dataSourceManager;
		$this->environment 			= $environment;
		$this->entityManager        = $entityManager;
		$this->imgPathURL           = $imgPathURL;

		parent::__construct($crudService, $parameterBag);
	}
	
	public function findDieta(DTO\Request\Filter $request, DTO\Response $response) {
		$filterCriteria = $request->getFilterCriteria();
		$filterCriteria->setDataSourceName("ger09200_dieta_padrao");
		$filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
		$newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria, array());
		$dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
		$newDataSet = $this->setImgFullPath($dataSet);
        $response->addDataSet($newDataSet);
	}

	private function setImgFullPath($dataSet) {
		$rows = $dataSet->getRows();
		foreach ($rows as &$row) {
			if ($row["DSIMAGDIET"] !== null) {
				$row["DSFOTOFILE"] = $row["DSIMAGDIET"];
				$row["DSIMAGDIET"] = $this->imgPathURL.$row["DSIMAGDIET"];
			}
		}
		return new DataSet("ger09200_dieta_padrao", $rows);
	}
	
	public function salvarDieta(DTO\Request $request, DTO\Response $response) {
		try{
			$this->dataSourceName = 'ger09200_dieta_padrao';
			$this->parameterBagColumns = array();
			$this->dataSourceNameToSave = $this->crudService->getDataSourceNameToSaveByName($this->dataSourceName);
			$this->dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
			$rows = $request->getDataSet()->getRows();
			foreach ($rows as &$row) {
				if (isset($row["IMAGE_UPLOAD"]) && isset($row["IMAGE_UPLOAD"]["0"]) 
				&& isset($row["IMAGE_UPLOAD"]["0"]["path"]) && $row["IMAGE_UPLOAD"]["0"]["path"] !== null) {
					$row["DSIMAGDIET"] = $row["IMAGE_UPLOAD"]["0"]["path"];
				} else {
					if(!empty($row["DSFOTOFILE"]))
						$row["DSIMAGDIET"] = $row["DSFOTOFILE"];
				}
				$row = $this->crudService->getRowsToSave($request, $this->dataSourceName);
				$this->crudService->save($this->dataSourceName, array($row[0]));
			}
			$response->setDataSets(new DataSet('SUCCESS'));
		}catch(\Exception $e) {
			throw $e;
		}
	}
	
	public function VerificaGrupoDieta(DTO\Request $request, DTO\Response $response) {
		$row = $request->getRow();
		$sql = "SELECT CDDIETPAD FROM DIETPADR WHERE CDDIETGRUP = :CDDIETPAD";
		$params = array("CDDIETPAD" => $row['CDDIETPAD']);
		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        $response->addDataSet(new DataSet("DIETA", $result));
	}
	
	public function VerificaDietaPadrao(DTO\Request $request, DTO\Response $response) {
		$row = $request->getRow();
		$sql = "SELECT CDDIETPAD FROM DIETSERV WHERE CDDIETPAD = :CDDIETPAD";
		$params = array("CDDIETPAD" => $row['CDDIETPAD']);
		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        $response->addDataSet(new DataSet("DIETA", $result));
	}
}